/* Plug.c generated by valac 0.36.4, the Vala compiler
 * generated from Plug.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <switchboard.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gmodule.h>


#define BLUETOOTH_TYPE_PLUG (bluetooth_plug_get_type ())
#define BLUETOOTH_PLUG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_TYPE_PLUG, BluetoothPlug))
#define BLUETOOTH_PLUG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BLUETOOTH_TYPE_PLUG, BluetoothPlugClass))
#define BLUETOOTH_IS_PLUG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_TYPE_PLUG))
#define BLUETOOTH_IS_PLUG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BLUETOOTH_TYPE_PLUG))
#define BLUETOOTH_PLUG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BLUETOOTH_TYPE_PLUG, BluetoothPlugClass))

typedef struct _BluetoothPlug BluetoothPlug;
typedef struct _BluetoothPlugClass BluetoothPlugClass;
typedef struct _BluetoothPlugPrivate BluetoothPlugPrivate;

#define BLUETOOTH_TYPE_MAIN_VIEW (bluetooth_main_view_get_type ())
#define BLUETOOTH_MAIN_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_TYPE_MAIN_VIEW, BluetoothMainView))
#define BLUETOOTH_MAIN_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BLUETOOTH_TYPE_MAIN_VIEW, BluetoothMainViewClass))
#define BLUETOOTH_IS_MAIN_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_TYPE_MAIN_VIEW))
#define BLUETOOTH_IS_MAIN_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BLUETOOTH_TYPE_MAIN_VIEW))
#define BLUETOOTH_MAIN_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BLUETOOTH_TYPE_MAIN_VIEW, BluetoothMainViewClass))

typedef struct _BluetoothMainView BluetoothMainView;
typedef struct _BluetoothMainViewClass BluetoothMainViewClass;

#define BLUETOOTH_SERVICES_TYPE_OBJECT_MANAGER (bluetooth_services_object_manager_get_type ())
#define BLUETOOTH_SERVICES_OBJECT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_SERVICES_TYPE_OBJECT_MANAGER, BluetoothServicesObjectManager))
#define BLUETOOTH_SERVICES_OBJECT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BLUETOOTH_SERVICES_TYPE_OBJECT_MANAGER, BluetoothServicesObjectManagerClass))
#define BLUETOOTH_SERVICES_IS_OBJECT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_SERVICES_TYPE_OBJECT_MANAGER))
#define BLUETOOTH_SERVICES_IS_OBJECT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BLUETOOTH_SERVICES_TYPE_OBJECT_MANAGER))
#define BLUETOOTH_SERVICES_OBJECT_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BLUETOOTH_SERVICES_TYPE_OBJECT_MANAGER, BluetoothServicesObjectManagerClass))

typedef struct _BluetoothServicesObjectManager BluetoothServicesObjectManager;
typedef struct _BluetoothServicesObjectManagerClass BluetoothServicesObjectManagerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _BluetoothPlugSearchData BluetoothPlugSearchData;

struct _BluetoothPlug {
	SwitchboardPlug parent_instance;
	BluetoothPlugPrivate * priv;
};

struct _BluetoothPlugClass {
	SwitchboardPlugClass parent_class;
};

struct _BluetoothPlugPrivate {
	BluetoothMainView* main_view;
	BluetoothServicesObjectManager* manager;
};

struct _BluetoothPlugSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	BluetoothPlug* self;
	gchar* search;
	GeeTreeMap* result;
	GeeTreeMap* search_results;
	GCompareFunc _tmp0_;
	GEqualFunc _tmp1_;
	GeeTreeMap* _tmp2_;
};


static gpointer bluetooth_plug_parent_class = NULL;

GType bluetooth_plug_get_type (void) G_GNUC_CONST;
GType bluetooth_main_view_get_type (void) G_GNUC_CONST;
GType bluetooth_services_object_manager_get_type (void) G_GNUC_CONST;
#define BLUETOOTH_PLUG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BLUETOOTH_TYPE_PLUG, BluetoothPlugPrivate))
enum  {
	BLUETOOTH_PLUG_DUMMY_PROPERTY
};
BluetoothPlug* bluetooth_plug_new (void);
BluetoothPlug* bluetooth_plug_construct (GType object_type);
BluetoothServicesObjectManager* bluetooth_services_object_manager_new (void);
BluetoothServicesObjectManager* bluetooth_services_object_manager_construct (GType object_type);
static GtkWidget* bluetooth_plug_real_get_widget (SwitchboardPlug* base);
BluetoothMainView* bluetooth_main_view_new (BluetoothServicesObjectManager* manager);
BluetoothMainView* bluetooth_main_view_construct (GType object_type, BluetoothServicesObjectManager* manager);
static void bluetooth_plug_real_shown (SwitchboardPlug* base);
void bluetooth_main_view_discoverable (BluetoothMainView* self, gboolean is_discoverable);
static void bluetooth_plug_real_hidden (SwitchboardPlug* base);
static void bluetooth_plug_real_search_callback (SwitchboardPlug* base, const gchar* location);
static void bluetooth_plug_real_search_data_free (gpointer _data);
static void bluetooth_plug_real_search (SwitchboardPlug* base, const gchar* search, GAsyncReadyCallback _callback_, gpointer _user_data_);
static gboolean bluetooth_plug_real_search_co (BluetoothPlugSearchData* _data_);
static void bluetooth_plug_finalize (GObject * obj);
SwitchboardPlug* get_plug (GModule* module);


BluetoothPlug* bluetooth_plug_construct (GType object_type) {
	BluetoothPlug * self = NULL;
	GeeTreeMap* settings = NULL;
	GeeTreeMap* _tmp0_;
	BluetoothServicesObjectManager* _tmp1_;
	BluetoothServicesObjectManager* _tmp2_;
#line 26 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 26 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	settings = _tmp0_;
#line 27 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "network/bluetooth", NULL);
#line 28 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	self = (BluetoothPlug*) g_object_new (object_type, "category", SWITCHBOARD_PLUG_CATEGORY_NETWORK, "code-name", "network-pantheon-bluetooth", "display-name", _ ("Bluetooth"), "description", _ ("Configure Bluetooth Settings"), "icon", "bluetooth", "supported-settings", settings, NULL);
#line 34 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_tmp1_ = bluetooth_services_object_manager_new ();
#line 34 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_g_object_unref0 (self->priv->manager);
#line 34 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	self->priv->manager = _tmp1_;
#line 35 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_tmp2_ = self->priv->manager;
#line 35 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp2_, "has-object", (GObject*) self, "can-show", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 25 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_g_object_unref0 (settings);
#line 25 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	return self;
#line 155 "Plug.c"
}


BluetoothPlug* bluetooth_plug_new (void) {
#line 25 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	return bluetooth_plug_construct (BLUETOOTH_TYPE_PLUG);
#line 162 "Plug.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 43 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	return self ? g_object_ref (self) : NULL;
#line 169 "Plug.c"
}


static GtkWidget* bluetooth_plug_real_get_widget (SwitchboardPlug* base) {
	BluetoothPlug * self;
	GtkWidget* result = NULL;
	BluetoothMainView* _tmp0_;
	BluetoothMainView* _tmp3_;
	GtkWidget* _tmp4_;
#line 38 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	self = (BluetoothPlug*) base;
#line 39 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_tmp0_ = self->priv->main_view;
#line 39 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	if (_tmp0_ == NULL) {
#line 185 "Plug.c"
		BluetoothServicesObjectManager* _tmp1_;
		BluetoothMainView* _tmp2_;
#line 40 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
		_tmp1_ = self->priv->manager;
#line 40 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
		_tmp2_ = bluetooth_main_view_new (_tmp1_);
#line 40 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
		g_object_ref_sink (_tmp2_);
#line 40 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
		_g_object_unref0 (self->priv->main_view);
#line 40 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
		self->priv->main_view = _tmp2_;
#line 198 "Plug.c"
	}
#line 43 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_tmp3_ = self->priv->main_view;
#line 43 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_tmp4_ = _g_object_ref0 ((GtkWidget*) _tmp3_);
#line 43 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	result = _tmp4_;
#line 43 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	return result;
#line 208 "Plug.c"
}


static void bluetooth_plug_real_shown (SwitchboardPlug* base) {
	BluetoothPlug * self;
	BluetoothMainView* _tmp0_;
#line 46 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	self = (BluetoothPlug*) base;
#line 47 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_tmp0_ = self->priv->main_view;
#line 47 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	bluetooth_main_view_discoverable (_tmp0_, TRUE);
#line 221 "Plug.c"
}


static void bluetooth_plug_real_hidden (SwitchboardPlug* base) {
	BluetoothPlug * self;
	BluetoothMainView* _tmp0_;
#line 50 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	self = (BluetoothPlug*) base;
#line 51 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_tmp0_ = self->priv->main_view;
#line 51 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	bluetooth_main_view_discoverable (_tmp0_, FALSE);
#line 234 "Plug.c"
}


static void bluetooth_plug_real_search_callback (SwitchboardPlug* base, const gchar* location) {
	BluetoothPlug * self;
#line 54 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	self = (BluetoothPlug*) base;
#line 54 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	g_return_if_fail (location != NULL);
#line 244 "Plug.c"
}


static void bluetooth_plug_real_search_data_free (gpointer _data) {
	BluetoothPlugSearchData* _data_;
	_data_ = _data;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_g_free0 (_data_->search);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_g_object_unref0 (_data_->result);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_g_object_unref0 (_data_->self);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	g_slice_free (BluetoothPlugSearchData, _data_);
#line 259 "Plug.c"
}


static void bluetooth_plug_real_search (SwitchboardPlug* base, const gchar* search, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	BluetoothPlug * self;
	BluetoothPlugSearchData* _data_;
	BluetoothPlug* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	self = (BluetoothPlug*) base;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_data_ = g_slice_new0 (BluetoothPlugSearchData);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, bluetooth_plug_real_search);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, bluetooth_plug_real_search_data_free);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_data_->self = _tmp0_;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_tmp1_ = search;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_g_free0 (_data_->search);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_data_->search = _tmp2_;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	bluetooth_plug_real_search_co (_data_);
#line 291 "Plug.c"
}


static GeeTreeMap* bluetooth_plug_real_search_finish (SwitchboardPlug* base, GAsyncResult* _res_) {
	GeeTreeMap* result;
	BluetoothPlugSearchData* _data_;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	result = _data_->result;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_data_->result = NULL;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	return result;
#line 306 "Plug.c"
}


static gboolean bluetooth_plug_real_search_co (BluetoothPlugSearchData* _data_) {
#line 59 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	switch (_data_->_state_) {
#line 59 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
		case 0:
#line 315 "Plug.c"
		goto _state_0;
		default:
#line 59 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
		g_assert_not_reached ();
#line 320 "Plug.c"
	}
	_state_0:
#line 60 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_data_->_tmp0_ = g_strcmp0;
#line 60 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_data_->_tmp1_ = g_str_equal;
#line 60 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_data_->_tmp2_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, (GCompareDataFunc) _data_->_tmp0_, NULL, NULL, (GeeEqualDataFunc) _data_->_tmp1_, NULL, NULL);
#line 60 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_data_->search_results = _data_->_tmp2_;
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_data_->result = _data_->search_results;
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	if (_data_->_state_ == 0) {
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 337 "Plug.c"
	} else {
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 341 "Plug.c"
	}
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	g_object_unref (_data_->_async_result);
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	return FALSE;
#line 347 "Plug.c"
}


static void bluetooth_plug_class_init (BluetoothPlugClass * klass) {
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	bluetooth_plug_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	g_type_class_add_private (klass, sizeof (BluetoothPlugPrivate));
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug *)) bluetooth_plug_real_get_widget;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug *)) bluetooth_plug_real_shown;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug *)) bluetooth_plug_real_hidden;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug *, const gchar*)) bluetooth_plug_real_search_callback;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search = (void (*) (SwitchboardPlug *, const gchar*, GAsyncReadyCallback, gpointer)) bluetooth_plug_real_search;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_finish = (GeeTreeMap* (*) (SwitchboardPlug *, GAsyncResult*)) bluetooth_plug_real_search_finish;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	G_OBJECT_CLASS (klass)->finalize = bluetooth_plug_finalize;
#line 370 "Plug.c"
}


static void bluetooth_plug_instance_init (BluetoothPlug * self) {
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	self->priv = BLUETOOTH_PLUG_GET_PRIVATE (self);
#line 377 "Plug.c"
}


static void bluetooth_plug_finalize (GObject * obj) {
	BluetoothPlug * self;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_PLUG, BluetoothPlug);
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_g_object_unref0 (self->priv->main_view);
#line 23 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_g_object_unref0 (self->priv->manager);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	G_OBJECT_CLASS (bluetooth_plug_parent_class)->finalize (obj);
#line 391 "Plug.c"
}


GType bluetooth_plug_get_type (void) {
	static volatile gsize bluetooth_plug_type_id__volatile = 0;
	if (g_once_init_enter (&bluetooth_plug_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BluetoothPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BluetoothPlug), 0, (GInstanceInitFunc) bluetooth_plug_instance_init, NULL };
		GType bluetooth_plug_type_id;
		bluetooth_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_PLUG, "BluetoothPlug", &g_define_type_info, 0);
		g_once_init_leave (&bluetooth_plug_type_id__volatile, bluetooth_plug_type_id);
	}
	return bluetooth_plug_type_id__volatile;
}


SwitchboardPlug* get_plug (GModule* module) {
	SwitchboardPlug* result = NULL;
	BluetoothPlug* plug = NULL;
	BluetoothPlug* _tmp0_;
#line 66 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 67 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	g_debug ("Plug.vala:67: Activating Bluetooth plug");
#line 68 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	_tmp0_ = bluetooth_plug_new ();
#line 68 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	plug = _tmp0_;
#line 69 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	result = (SwitchboardPlug*) plug;
#line 69 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Plug.vala"
	return result;
#line 423 "Plug.c"
}



